package  {
	import flash.display.MovieClip;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	import flash.media.SoundMixer;
	
	public class AA extends MovieClip {
		[Embed(source = 'click.mp3')] 		public static var click:Class;
		[Embed(source = 'deposit.mp3')] 	public static var deposit:Class;
		[Embed(source = 'giantdie.mp3')] 	public static var giantdie:Class;
		[Embed(source = 'hit1.mp3')] 		public static var hit1:Class;
		[Embed(source = 'hit2.mp3')] 		public static var hit2:Class;
		[Embed(source = 'hit3.mp3')] 		public static var hit3:Class;
		[Embed(source = 'hit4.mp3')] 		public static var hit4:Class;
		[Embed(source = 'hitspirit.mp3')]	public static var hitspirit:Class;
		[Embed(source = 'mageshoot.mp3')]	public static var mageshoot:Class;
		[Embed(source = 'pickup.mp3')] 		public static var pickup:Class;
		[Embed(source = 'rollover.mp3')] 	public static var rollover:Class;
		[Embed(source = 'yay.mp3')] 		public static var yay:Class;
		[Embed(source = 'throwjav1.mp3')] 		public static var throwjav1:Class;
		[Embed(source = 'throwjav2.mp3')] 		public static var throwjav2:Class;
		[Embed(source = 'throwjav3.mp3')] 		public static var throwjav3:Class;
		[Embed(source = 'javhit1.mp3')] 		public static var javhit1:Class;
		[Embed(source = 'javhit2.mp3')] 		public static var javhit2:Class;
		[Embed(source = 'javhit3.mp3')] 		public static var javhit3:Class;
		[Embed(source = 'wah.mp3')] 			public static var wah:Class;
		[Embed(source = 'door.mp3')] 			public static var door:Class;
		
		public static const arrHit:Array = [hit1, hit2, hit3, hit4];
		public static const arrJavHit:Array = [javhit1, javhit2, javhit3];
		public static const arrThrowJav:Array = [throwjav1, throwjav2, throwjav3];
		
		public static var bAudio:Boolean = true;
		public static var bMusic:Boolean = true;
		
		public static var music:Sound = null;
		public static var musicTrans:SoundTransform = null;
		public static var musicChannel:SoundChannel = null;
		public static var musicVolume:Number = 0.0;
		
		public static var musicVolumeModifer:Number = 1.0;
		public static var mainTransform:SoundTransform = new SoundTransform(1, 0);
		public static var mutedTransform:SoundTransform = new SoundTransform(0, 0);
		
		public static var prevMusic:Class = null;
		
		public static function ChangeMusic(_sound:Class):void {
			if (prevMusic == _sound)
				return;
				
			if (musicChannel != null) {
				musicChannel.stop();
			}
			
			music = new _sound as Sound;
			musicVolume = 0.0;
			musicTrans = new SoundTransform(0.0, 0.0);
			musicChannel = music.play(0, int.MAX_VALUE, musicTrans);
			prevMusic = _sound;
		}
		
		public static function Play(_sound:Class, _volume:Number = 1.0):void {
			//if (_sound == rollover)
			//	_volume = 0.4;
			var snd:Sound = new _sound;
			var trans:SoundTransform = new SoundTransform;
			trans.volume = _volume;
			snd.play(0, 0, trans);
		}
		
		public static function PlayRandom(_sounds:Array, _volume:Number=1.0):void {
			var snd:Sound = new (_sounds[Math.floor(Math.random() * _sounds.length)] as Class) as Sound;
			var trans:SoundTransform = new SoundTransform;
			trans.volume = _volume;
			snd.play(0, 0, trans);
		}
		
		public static function Tick(_dt:Number):void {
			if (musicChannel != null) {
				//trace(musicVolume);
				musicVolume = Misc.Clamp(musicVolume + _dt * 0.5, 0.0, 1.0);
				var newTransform:SoundTransform = new SoundTransform(musicVolume * musicVolumeModifer, 0);
				musicChannel.soundTransform = newTransform;
			}
		}
		
		public static function ToggleMusic(_active:Boolean):void {
			if (_active)
				musicVolumeModifer = 1.0;
			else
				musicVolumeModifer = 0.0;
			bMusic = _active;
		}
		
		public static function ToggleAll(_active:Boolean):void {
			if (_active)
				SoundMixer.soundTransform = mainTransform;
			else
				SoundMixer.soundTransform = mutedTransform;
			bAudio = _active;
		}
	}
}