package {
	public class Laser extends Actor {
		var clip:Solids = null;
		var t:Number = 0;
		
		public function Laser(_x:Number, _y:Number, _destx:Number, _desty:Number, _color:int) {
			x = _x;
			y = _y;
			var len:Number = Misc.Length(_destx - _x, _desty - _y);
			scaleX = len / 100;
			rotation = Misc.ToDegrees(Math.atan2(_desty - _y, _destx - _x));
			
			clip = new Solids;
			if (_color == T.color_red)
				clip.gotoAndStop(8);
			else if (_color == T.color_blue)
				clip.gotoAndStop(9);
			else
				clip.gotoAndStop(10);
			addChild(clip);
			
			AddEventListener(GEvent.Tick, Tick);
			AddEventListener(GEvent.OnTimeOver, OnTimeOver);
			AddToLayer(g.layerTop);
		}
		
		public function Tick(e:GEvent):void {
			alpha = 1.0 - t;
			t += T.dt;
			if (t >= 1.0)
				Kill();
		}
		
		public function OnTimeOver(e:GEvent):void {
			Kill();
		}
	}
}