﻿package  {
	import fl.transitions.easing.Back;
	import fl.transitions.easing.Elastic;
	import fl.transitions.easing.None;
	import fl.transitions.easing.Regular;
	import fl.transitions.Tween;
	import flash.display.MovieClip;
	
	public class ResourceHud extends Actor {
		var tween:Tween = null;
		
		public function ResourceHud() {
			AddToLayer(g.layerUI);
			AddEventListener(GEvent.Tick, Tick);
			
			res1.gotoAndStop(1);
			res2.gotoAndStop(2);
			res3.gotoAndStop(3);
			res4.gotoAndStop(4);
			
			UpdateInterface();
		}
		
		public function GoDown():void {
			tween = new Tween(this, "y", Back.easeIn, 0, 160, 0.75, true);
		}
		
		public function GoUp():void {
			tween = new Tween(this, "y", Back.easeIn, 160, 0, 0.75, true);
		}
		
		public function UpdateInterface():void {
			res3.visible = g.showBlueGiant;
			res4.visible = g.showYellowGiant;
		}
		
		public function Tick(e:GEvent):void {			
			res1.label.text = "" + g.resources[0];
			res2.label.text = "" + g.resources[1];
			if (res3.label)
				res3.label.text = "" + g.resources[2];
			if (res4.label)
				res4.label.text = "" + g.resources[3];
		}
	}
}


























