package  {
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	
	public class T {
		public static const width:Number = 700;
		public static const height:Number = 400;
		public static const dt:Number = 1.0 / 30.0;
		public static const version:String = "v1";
		
		public static const dev_debugHud:Boolean 			= false;
		public static const dev_skipDialog:Boolean 			= false;
		public static const dev_skipDialogFuncs:Boolean 	= false;
		public static const dev_weakGiants:Boolean 			= false;
		public static const dev_instantGameWin:Boolean 		= false;
		public static const dev_lastBattle:Boolean 			= false;
		
		public static const state_waiting:int		= 0;
		public static const state_live:int			= 1;
		
		public static const color_red:int			= 0;
		public static const color_blue:int			= 1;
		public static const color_yellow:int		= 2;
		
		public static const proj_javelin:Object		= { damage:1, frame:1, speed:200, maxTime:1.0 };
		public static const proj_red:Object			= { damage:1, frame:5, speed:300, maxTime:2.0, color:color_red };
		public static const proj_blue:Object		= { damage:1, frame:6, speed:300, maxTime:2.0, color:color_blue };
		public static const proj_yellow:Object		= { damage:1, frame:7, speed:300, maxTime:2.0, color:color_yellow };
		
		public static const pawn_gatherer:Object 		= { index:0, frame:1, proj:null,			speed:170 };
		public static const pawn_javelin:Object 		= { index:1, frame:2, proj:proj_javelin,	speed:210 };
		public static const pawn_red_mage:Object 		= { index:2, frame:3, proj:proj_red,		speed:120 };
		public static const pawn_blue_mage:Object 		= { index:3, frame:4, proj:proj_blue,		speed:120 };
		public static const pawn_yellow_mage:Object 	= { index:4, frame:5, proj:proj_yellow,		speed:120 };
		public static const pawnTypes:Array = [
			pawn_gatherer,
			pawn_javelin,
			pawn_red_mage,
			pawn_blue_mage,
			pawn_yellow_mage
		];
		public static const numPawnTypes:int		= pawnTypes.length;
		
		public static const crop_javelin:Object		= { index:0, frame:1 };
		public static const crop_red:Object			= { index:1, color:color_red, frame:2 };
		public static const crop_blue:Object		= { index:2, color:color_blue, frame:3 };
		public static const crop_yellow:Object		= { index:3, color:color_yellow, frame:4 };
		
		public static const enemy_red:Object		= { hp:20 };
		
		public static const giant_red:Object		= { frame:1, color:color_red,		health:5,	crop:crop_red };
		public static const giant_blue:Object		= { frame:2, color:color_blue,		health:5,	crop:crop_blue };
		public static const giant_yellow:Object		= { frame:3, color:color_yellow,	health:5,	crop:crop_yellow };
		
		public static const spirit_red:Object		= { frame:1, color:color_red };
		public static const spirit_blue:Object		= { frame:2, color:color_blue };
		public static const spirit_yellow:Object	= { frame:3, color:color_yellow };
		
		public static const speaker_doctor:int		= 1;
		public static const speaker_chief:int		= 2;
		public static const speaker_daughter:int	= 3;
		
		public static const dialog:Array = [
			// 0
			[
				{speaker:speaker_daughter, 	func:null,				caption:"Father..."},
				{speaker:speaker_chief, 	func:null,				caption:"Shhh.. my daughter.\nPlease save your strength."},
				{speaker:speaker_daughter, 	func:null,				caption:"Father...\nI do not have much time." },
				{speaker:speaker_daughter, 	func:null,				caption:"The spirits... I can see them." },
				{speaker:speaker_daughter, 	func:null,				caption:"They have come to take me away." },
				{speaker:speaker_chief, 	func:null,				caption:"No.. Stay with me!" },
				{speaker:speaker_daughter, 	func:null,				caption:"..." },
				{speaker:speaker_chief, 	func:null,				caption:"No..." },
				{speaker:speaker_chief, 	func:null,				caption:"... No!" },
				{speaker:speaker_chief, 	func:null,				caption:"... Nooo!!!!" },
				{speaker:speaker_doctor, 	func:null,				caption:"Chief, I am sorry." },
				{speaker:speaker_doctor, 	func:null,				caption:"She is gone." },
				{speaker:speaker_doctor, 	func:null,				caption:"Taken by the spirits." },
				{speaker:speaker_chief, 	func:null,				caption:"This cannot be!" },
				{speaker:speaker_doctor, 	func:null,				caption:"But there is still a chance...\nTo save her." },
				{speaker:speaker_chief, 	func:null,				caption:"What?! Speak now!" },
				{speaker:speaker_doctor, 	func:null,				caption:"With my magic, we can return 10 seconds before she passed." },
				{speaker:speaker_doctor, 	func:null,				caption:"Observe..." },
				{speaker:speaker_doctor, 	func:"ShowRedSpirits",	caption:"Observe..." },
				{speaker:speaker_chief, 	func:null,				caption:"I saw the spirits!" },
				{speaker:speaker_chief, 	func:null,				caption:"We must stop them!" },
				{speaker:speaker_doctor, 	func:null,				caption:"Chief, only red magic will harm them." },
				{speaker:speaker_doctor, 	func:"ShowRedGiant",	caption:"There is a guarded fountain of red magic to the northeast." },
				{speaker:speaker_doctor, 	func:null,				caption:"But is guarded by a totem." },
				{speaker:speaker_chief, 	func:null,				caption:"I do not care. We must stop the red spirits." },
				{speaker:speaker_chief, 	func:null,				caption:"My brave villagers will sacrifice themselves to save my daughter." },
				{speaker:speaker_doctor, 	func:"ShowPot",			caption:"..." },
				{speaker:speaker_chief, 	func:null,				caption:"We will gather some javelins nearby!" },
				null
			],
			// 1
			[
				{speaker:speaker_doctor, 	func:null,				caption:"Chief, we have the supplies for a javelineer." },
				{speaker:speaker_chief, 	func:null,				caption:"Good." },
				{speaker:speaker_chief, 	func:null,				caption:"But we are going to need many more." },
				null
			],
			// 2
			[
				{speaker:speaker_doctor, 	func:null,				caption:"Chief, your warriors have slain the totem!" },
				{speaker:speaker_chief, 	func:null,				caption:"Good." },
				{speaker:speaker_chief, 	func:null,				caption:"I will send some gatherers." },
				{speaker:speaker_doctor, 	func:null,				caption:"But Chief, remember there is only 10 seconds." },
				{speaker:speaker_doctor, 	func:null,				caption:"You need to kill the totem more quickly!" },
				{speaker:speaker_chief, 	func:null,				caption:"..Don't tell me how to save my daughter!" },
				{speaker:speaker_doctor, 	func:null,				caption:"Chief, I apologize." },
				null
			],
			// 3
			[
				{speaker:speaker_doctor, 	func:null,				caption:"Chief! Your gatherer collected red magic!" },
				{speaker:speaker_doctor, 	func:null,				caption:"This means we can create a red mage!" },
				{speaker:speaker_chief, 	func:null,				caption:"Are you still here?" },
				{speaker:speaker_chief, 	func:null,				caption:"Stop telling me how to save my daughter." },
				{speaker:speaker_doctor, 	func:null,				caption:"Sorry, Chief." },
				null
			],
			// 4
			[
				{speaker:speaker_chief, 	func:null,				caption:"..." },
				{speaker:speaker_chief, 	func:null,				caption:"I do not understand." },
				{speaker:speaker_chief, 	func:null,				caption:"We killed all the red spirits, but my daughter still died." },
				{speaker:speaker_doctor, 	func:null,				caption:"Chief, there must be others." },
				{speaker:speaker_chief, 	func:null,				caption:"How many others?" },
				{speaker:speaker_doctor, 	func:null,				caption:"Chief, I am having visions." },
				{speaker:speaker_doctor, 	func:null,				caption:"..Yes, I feel the presence of blue spirits." },
				{speaker:speaker_chief, 	func:"ShowBlueGiant",	caption:"I see where we can gather blue magic." },
				{speaker:speaker_chief, 	func:null,				caption:"We will crush that blue totem!" },
				{speaker:speaker_doctor, 	func:"ShowPot",			caption:"..." },
				null
			],
			// 5
			[
				{speaker:speaker_chief, 	func:null,				caption:"..." },
				{speaker:speaker_chief, 	func:null,				caption:"We have killed the red AND blue spirits!" },
				{speaker:speaker_doctor, 	func:null,				caption:"Chief, I feel the presence of yellow spirits." },
				{speaker:speaker_chief, 	func:null,				caption:"And do you feel the presence of pink or cyan spirits too?!" },
				{speaker:speaker_doctor, 	func:null,				caption:"Chief, only yellow spirits." },
				{speaker:speaker_chief, 	func:"ShowYellowGiant",	caption:"Then we will need yellow magic as well." },
				{speaker:speaker_chief, 	func:"ShowPot",			caption:"Send in the javelineers!" },
				null
			],
			// 6
			[
				{speaker:speaker_chief, 	func:null,				caption:"..." },
				{speaker:speaker_doctor, 	func:null,				caption:"Chief, all the spirits have been slain." },
				{speaker:speaker_chief, 	func:null,				caption:"My daughter was still taken by spirits." },
				{speaker:speaker_chief, 	func:null,				caption:"There must still be more?!." },
				{speaker:speaker_doctor, 	func:null,				caption:"Chief, I am... sorry." },
				{speaker:speaker_doctor, 	func:null,				caption:"I do not feel the presence of any other spirits." },
				{speaker:speaker_doctor, 	func:null,				caption:"We must find another witch doctor who can!" },
				{speaker:speaker_chief, 	func:null,				caption:"No..." },
				{speaker:speaker_doctor, 	func:null,				caption:"Chief?" },
				{speaker:speaker_chief, 	func:null,				caption:"No. My daughter already has endured enough pain." },
				{speaker:speaker_doctor, 	func:null,				caption:"Chief..." },
				{speaker:speaker_chief, 	func:null,				caption:"We must let her go." },
				{speaker:speaker_doctor, 	func:null,				caption:"Chief, are you sure?" },
				{speaker:speaker_chief, 	func:null,				caption:"Yes." },
				{speaker:speaker_chief, 	func:null,				caption:"These spirits... have been trying to help her!" },
				{speaker:speaker_chief, 	func:null,				caption:"They have come to release her from this painful world." },
				{speaker:speaker_chief, 	func:null,				caption:"Goodbye, my daughter." },
				{speaker:speaker_chief, 	func:"GameEnding",		caption:"..." },
				null
			],
			null
		];
		
		//======================================================================
		// URLS
		//======================================================================
		public static const URL_MoreGames:int			= 0;
		public static const URL_EpaceGames:int			= 1;
		public static const URL_Twitter:int				= 2;
		public static const URLS:Array = new Array(
			"http://www.flashgamelicense.com/",
			"http://www.epacegames.com/",
			"https://twitter.com/EpaceGames");
		public static function OpenURL(_url:int):void {
			var request:URLRequest;
			var url:String = URLS[_url];
			request = new URLRequest(url);
			try {
				navigateToURL(request, '_blank');
				//Stat_Custom("web:" + URLNames[_url]);
			}
			catch (e:Error) {
				trace("Error on loading URL: " + url);
			}
		}
	}
}






















