package {
	import flash.events.MouseEvent;
	import flash.ui.Mouse;
	public class Dialog extends Actor {
		var arr:Array = null;
		var currIndex:int = 0;
		var showingRedSpirits:Boolean = false;
		
		public function Dialog(_dialog:int) {
			arr = T.dialog[_dialog];
			AddToLayer(g.layerUI);
			AddEventListener(GEvent.Tick, Tick);
			
			bubble.bubble.overlay.addEventListener(MouseEvent.ROLL_OVER, BubbleRollOver, false, 0, true);
			bubble.bubble.overlay.addEventListener(MouseEvent.ROLL_OUT, BubbleRollOut, false, 0, true);
			bubble.bubble.overlay.addEventListener(MouseEvent.CLICK, ClickBubble, false, 0, true);
			bubble.bubble.overlay.buttonMode = true;
			bubble.gotoAndStop(6);
			
			Show(currIndex);
			currIndex++;
		}
		
		public function Tick(e:GEvent):void {
			if (showingRedSpirits && g.spirits.length <= 0) {
				visible = true;
				Show(currIndex);
				currIndex++;
				showingRedSpirits = false;
			}
		}
		
		public function BubbleRollOver(e:MouseEvent):void {
			
		}
		
		public function BubbleRollOut(e:MouseEvent):void {
			
		}
		
		public function ClickBubble(e:MouseEvent):void {
			if (arr[currIndex]) {
				Show(currIndex);
				currIndex++;
			}
			else {
				Kill();
				g.PrompForNextBattle();
			}
		}
		
		public function Show(_index:int):void {
			bubble.gotoAndPlay(1);
			
			var obj:Object = arr[_index];
			
			var frame:String = null;
			if (obj.speaker == T.speaker_doctor) {
				if (currentLabel != "doc")
					gotoAndPlay("doc");
			}
			else if (obj.speaker == T.speaker_daughter) {
				if (currentLabel != "daughter")
					gotoAndPlay("daughter");
			}
			else if (obj.speaker == T.speaker_chief) {
				if (currentLabel != "chief")
					gotoAndPlay("chief");
			}
			
			AA.Play(AA.rollover);
			
			bubble.bubble.caption.text = obj.caption;
			if (!T.dev_skipDialogFuncs) {
				if (obj.func) {
					this[obj.func]();
				}
			}
		}
		
		public function ShowRedSpirits():void {
			AA.Play(AA.wah);
			showingRedSpirits = true;
			g.CreateRedSpirits();
			visible = false;
		}
		
		public function ShowRedGiant():void {
			g.lookAtRedGiant = true;
			g.CreateRedGiant();
		}
		
		public function ShowPot():void {
			g.lookAtRedGiant = false;
			g.lookAtBlueGiant = false;
			g.lookAtYellowGiant = false;
		}
		
		public function ShowBlueGiant():void {
			g.lookAtBlueGiant = true;
			g.CreateBlueGiant();
		}
		
		public function ShowYellowGiant():void {
			g.lookAtYellowGiant = true;
			g.CreateYellowGiant();
		}
		
		public function CalcTheta():void {
			(bubble.bubble.caption.text as String).replace("(theta)", "" + g.numTimesKilled);
		}
		
		public function GameEnding():void {
			visible = false;
			//trace("ending");
			new GameWin;
		}
	}
}






























