﻿package  {
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.geom.Point;
	public class Giant extends Actor {
		var type:Object = null;
		var nextAttack:Number = 0;
		var damageRedness:Number = 0;
		
		public function Giant(_x:Number, _y:Number, _type:Object) {
			x = _x;
			y = _y;
			type = _type;
			
			clip.gotoAndStop(type.frame);
			
			health = type.health;
			
			if (type == T.giant_blue)
				scaleX = -1;
			
			if (T.dev_weakGiants)
				health = 1;
			
			AddToLayer(g.layerSorted);
			AddToContainer(g.sorted);
			AddToContainer(g.giants);
			
			AddEventListener(GEvent.Tick, Tick);
			AddEventListener(GEvent.OnTimeOver, OnTimeOver);
		}
		
		public function Tick(e:GEvent):void {
			var i:int;
			
			damageRedness -= T.dt * 3;
			if (damageRedness < 0.0)
				damageRedness = 0.0;
			Misc.SetRedness(this, damageRedness * 0.9);
			
			if (nextAttack < g.time) {
				var rad2:Number = 250 * 250;
				for (i = 0; i < g.pawns.length; i++) {
					var pawn:Pawn = g.pawns[i];
					if (pawn.IsAlive()) {
						var dist2:Number = Misc.Length2(pawn.x - x, pawn.y - (y - 113*0.5));
						if (dist2 <= rad2) {
							pawn.Hurt(9999);
							
							var actualPos:Point;
							
							//new Laser(x, y - 70, pawn.x, pawn.y, type.color);
							actualPos = clip.eye1.localToGlobal(new Point);
							actualPos.x -= g.layerScroll.x;
							actualPos.y -= g.layerScroll.y;
							new Laser(actualPos.x, actualPos.y, pawn.x, pawn.y, type.color);
							actualPos = clip.eye2.localToGlobal(new Point);
							actualPos.x -= g.layerScroll.x;
							actualPos.y -= g.layerScroll.y;
							new Laser(actualPos.x, actualPos.y, pawn.x, pawn.y, type.color);
							
							nextAttack = g.time + 1;
							break;
						}
					}
				}
			}
			
			depthValue = y;
		}
		
		public function Hurt(_damage:int, _proj:Projectile):void {
			if (IsAlive()) {
				health -= _damage;
				damageRedness = 1;
				if (IsAlive()) {
					//AA.PlayRandom(AA.arrHit);
					AA.PlayRandom(AA.arrJavHit);
				}
				else {
					AA.Play(AA.giantdie);
					if (type == T.giant_red)
						g.slainRedGiant = true;
					new Crop(x, y, type.crop);
					Kill();
				}
			}
		}
		
		public function PointInside(_x:Number, _y:Number):Boolean {
			return Misc.PointInsideCustomAABB(_x, _y, x - 52*0.5, y - 113, x + 52*0.5, y);
		}
		
		public function OnTimeOver(e:GEvent):void {
			Kill();
		}
	}
}



























