﻿package  {
	import flash.display.MovieClip;
	public class Spirit extends Actor {
		var t:Number = 0;
		var step:Number = 0;
		var rotstep:Number = 0;
		var theta:Number = 0;
		var rad0:Number = 0;
		var type:Object = null;
		var dir:Number = 0;
		var prev_x:Number = 0;
		var prev_y:Number = 0;
		
		public function Spirit(_rad0:Number, _revPerSecond:Number, _timeToReachCenter:Number, _angle:Number, _dir:Number, _type:Object) {
			// hacks!!
			_revPerSecond *= 0.5;
			_rad0 *= 0.4;
			
			rad0 = _rad0;
			step = 1.0 / _timeToReachCenter;
			rotstep = _revPerSecond * 360.0;
			theta = _angle;
			dir = _dir;
			
			health = 1;
			t = 0;
			type = _type;
			gotoAndStop(type.frame);
			
			if (type == T.spirit_red)
				g.numRedSpiritsCreated++;
			else if (type == T.spirit_blue)
				g.numBlueSpiritsCreated++;
			else if (type == T.spirit_yellow)
				g.numYellowSpiritsCreated++;
			
			asdf.gotoAndPlay(Misc.RandomInt(1, 8));
				
			Tick(null);
			AddToContainer(g.spirits);
			AddToLayer(g.layerSpirits);
			AddEventListener(GEvent.Tick, Tick);
			AddEventListener(GEvent.OnTimeOver, OnTimeOver);
		}
		
		public function Tick(e:GEvent):void {
			t += step * T.dt;
			theta += rotstep * T.dt;
			if (t >= 1.0) {
				t = 1.0;
				Kill();
			}
			var rad:Number = Misc.Lerp(rad0, 0, t);
			
			prev_x = x;
			prev_y = y;
			
			x = 400 + Math.cos(Misc.ToRadians(theta * dir)) * rad;
			y = 300 + Math.sin(Misc.ToRadians(theta * dir)) * rad;
			
			rotation = Misc.ToDegrees(Math.atan2(y - prev_y, x - prev_x)) + 90;
			//rotation = Misc.Lerp(rotation, Misc.ToDegrees(Math.atan2(y - prev_y, x - prev_x)) + 90, 0.9);
		}
		
		public function PointInside(_x:Number, _y:Number):Boolean {
			var len2:Number = Misc.Length2(x - _x, y - _y);
			if (len2 < 22 * 22)
				return true;
			return false;
		}
		
		public function TakeDamage(_amount:int):void {
			if (IsAlive()) {
				health -= _amount;
				if (!IsAlive()) {
					AA.Play(AA.hitspirit, 0.66);
					if (type == T.spirit_red)
						g.numRedSpiritsKilled++;
					else if (type == T.spirit_blue)
						g.numBlueSpiritsKilled++;
					else if (type == T.spirit_yellow)
						g.numYellowSpiritsKilled++;
					Kill();
				}
			}
		}
		
		public function OnTimeOver(e:GEvent):void {
			Kill();
		}
	}
}




























